#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QtGui>
#include <QString>
#include <time.h>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    my_timer = new QTimer();
    //
    //      タイマーシグナルtimeoutと処理用メソッドshow_timeの結合
    //
    connect(my_timer, SIGNAL(timeout()), this, SLOT(show_time()));
    my_timer->start(100);
    //
    //      ボタンのクリックclickedと処理用メソッドgoodByの結合
    //
    connect(ui->pushButton, SIGNAL(clicked()), this, SLOT(goodBy()));
}

MainWindow::~MainWindow()
{
    if (my_timer) delete my_timer;
    delete ui;
};

void MainWindow::paintEvent(QPaintEvent *event){
    //
    //      時刻を表す文字列をcvに設定
    //
    time_t vt;
    time(&vt);
    char * cstr = ctime(&vt);
    char cv[9];
    for (int i = 0; i < 8; i++)
        cv[i] = cstr[11+i];
    cv[8] = 0;
    //
    //      文字列cvをウィンドウ中央に描画
    //
    QPainter painter(this);
    painter.setPen(Qt::blue);
    painter.setFont(QFont("Arial", 100));
    painter.drawText(rect(), Qt::AlignCenter, QString(cv));
}

void MainWindow::show_time(){
        update();       //  paintEventの呼び出し
}

void MainWindow::goodBy(){
    exit(0);            //  プログラムの実行終了; exec()から抜け出す。
}
